#include <iostream>
using namespace std;

// Prottipos
void inserir (float v[], float n, int &pos, int max);
void listar (float v[], int quantidade);
int buscar (float v[], int quantidade, int n);
void remover (float v[], int &quantidade, int n);

// Programa Principal
int main(void) {
    // Declarao da lista de notas
    float notas[10];
    int quantidade;
    // Valor a ser lido
    float n;
    // Posio do resultado
    int pos;

    // Inicializa a Lista: contm, inicialmente, zero elementos
    quantidade = 0;

    // Leitura de N dado
    do {
        cout << "Digite valor: ";
        cin >> n;
        if (n != 0) inserir (notas, n, quantidade, 10);
    } while(n != 0);

    // Imprime vetor
    listar(notas, quantidade);

    // Busca valor
    cout << "Digite valor a buscar na lista: ";
    cin >> n;
    pos = buscar(notas, quantidade, n);
    if (pos >= 0) cout << "Encontrado em pos= " << pos << endl;
    else cout << "Valor nao encontrado na lista!";

    // Revover um valor
    cout << "Digite valor a remover da lista: ";
    cin >> n;
    remover(notas, quantidade, n);

    // Imprime vetor
    listar(notas, quantidade);
}

// Funo que Insere N na posio POS da lista V
void inserir (float v[], float n, int &pos, int max) {
    if (pos >= max) cout << "ERRO: Lista cheia!" << endl;
    else {
        v[pos] = n;
        pos++;
    }
}

// Funo que imprime os valores de um vetor
void listar (float v[], int quantidade) {
    int i;
    for (i=0; i<quantidade; i++) {
        cout << v[i] << endl;
    }
}

int buscar (float v[], int quantidade, int n) {
    int i;
    for (i=0; i<quantidade; i++) {
        if (v[i] == n) return i;
    }
    return -1;
}

void remover (float v[], int &quantidade, int n) {
    int pos;
    if (quantidade == 0) cout << "ERRO: Lista Vazia!" << endl;
    else {
        pos = buscar(v, quantidade, n);
        if (pos < 0) cout << "ERRO: Elemento inexistente!" << endl;
        else {
            v[pos] = v[quantidade-1];
            quantidade--;
        }
    }
}
